# coding: utf-8

"""
    Idfy.Admin

    In this API you can manage your account details, logo, styling or manage your openid / oauth api clients. If you are a dealer you can also manage the accounts registered to this dealer.   ## Last update   Last build date for this API: 14.01.2018  

"""


import pprint
import re
from typing import List, Dict
from datetime import datetime as datetime


class AccountSearchFilter(object):
    """NOTE: This class is generated by Eivind.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': str,
        'org_no': str,
        'uni_customer_no': str,
        'created_before': datetime,
        'created_after': datetime,
        'last_modified_before': datetime,
        'last_modified_after': datetime,
        'dealer_name': str,
        'dealer_reference': str,
        'enabled': bool
    }

    attribute_map = {
        'name': 'Name',
        'org_no': 'OrgNo',
        'uni_customer_no': 'UniCustomerNo',
        'created_before': 'CreatedBefore',
        'created_after': 'CreatedAfter',
        'last_modified_before': 'LastModifiedBefore',
        'last_modified_after': 'LastModifiedAfter',
        'dealer_name': 'DealerName',
        'dealer_reference': 'DealerReference',
        'enabled': 'Enabled'
    }

    def __init__(self, name=None, org_no=None, uni_customer_no=None, created_before=None, created_after=None, last_modified_before=None, last_modified_after=None, dealer_name=None, dealer_reference=None, enabled=None):

        self._name = None
        self._org_no = None
        self._uni_customer_no = None
        self._created_before = None
        self._created_after = None
        self._last_modified_before = None
        self._last_modified_after = None
        self._dealer_name = None
        self._dealer_reference = None
        self._enabled = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if org_no is not None:
            self.org_no = org_no
        if uni_customer_no is not None:
            self.uni_customer_no = uni_customer_no
        if created_before is not None:
            self.created_before = created_before
        if created_after is not None:
            self.created_after = created_after
        if last_modified_before is not None:
            self.last_modified_before = last_modified_before
        if last_modified_after is not None:
            self.last_modified_after = last_modified_after
        if dealer_name is not None:
            self.dealer_name = dealer_name
        if dealer_reference is not None:
            self.dealer_reference = dealer_reference
        if enabled is not None:
            self.enabled = enabled

    @property
    def name(self):
        """Gets the name of this AccountSearchFilter.


        :return: The name of this AccountSearchFilter.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AccountSearchFilter.


        :param name: The name of this AccountSearchFilter.
        :type: str
        """

        self._name = name

    @property
    def org_no(self):
        """Gets the org_no of this AccountSearchFilter.


        :return: The org_no of this AccountSearchFilter.
        :rtype: str
        """
        return self._org_no

    @org_no.setter
    def org_no(self, org_no):
        """Sets the org_no of this AccountSearchFilter.


        :param org_no: The org_no of this AccountSearchFilter.
        :type: str
        """

        self._org_no = org_no

    @property
    def uni_customer_no(self):
        """Gets the uni_customer_no of this AccountSearchFilter.


        :return: The uni_customer_no of this AccountSearchFilter.
        :rtype: str
        """
        return self._uni_customer_no

    @uni_customer_no.setter
    def uni_customer_no(self, uni_customer_no):
        """Sets the uni_customer_no of this AccountSearchFilter.


        :param uni_customer_no: The uni_customer_no of this AccountSearchFilter.
        :type: str
        """

        self._uni_customer_no = uni_customer_no

    @property
    def created_before(self):
        """Gets the created_before of this AccountSearchFilter.


        :return: The created_before of this AccountSearchFilter.
        :rtype: datetime
        """
        return self._created_before

    @created_before.setter
    def created_before(self, created_before):
        """Sets the created_before of this AccountSearchFilter.


        :param created_before: The created_before of this AccountSearchFilter.
        :type: datetime
        """

        self._created_before = created_before

    @property
    def created_after(self):
        """Gets the created_after of this AccountSearchFilter.


        :return: The created_after of this AccountSearchFilter.
        :rtype: datetime
        """
        return self._created_after

    @created_after.setter
    def created_after(self, created_after):
        """Sets the created_after of this AccountSearchFilter.


        :param created_after: The created_after of this AccountSearchFilter.
        :type: datetime
        """

        self._created_after = created_after

    @property
    def last_modified_before(self):
        """Gets the last_modified_before of this AccountSearchFilter.


        :return: The last_modified_before of this AccountSearchFilter.
        :rtype: datetime
        """
        return self._last_modified_before

    @last_modified_before.setter
    def last_modified_before(self, last_modified_before):
        """Sets the last_modified_before of this AccountSearchFilter.


        :param last_modified_before: The last_modified_before of this AccountSearchFilter.
        :type: datetime
        """

        self._last_modified_before = last_modified_before

    @property
    def last_modified_after(self):
        """Gets the last_modified_after of this AccountSearchFilter.


        :return: The last_modified_after of this AccountSearchFilter.
        :rtype: datetime
        """
        return self._last_modified_after

    @last_modified_after.setter
    def last_modified_after(self, last_modified_after):
        """Sets the last_modified_after of this AccountSearchFilter.


        :param last_modified_after: The last_modified_after of this AccountSearchFilter.
        :type: datetime
        """

        self._last_modified_after = last_modified_after

    @property
    def dealer_name(self):
        """Gets the dealer_name of this AccountSearchFilter.


        :return: The dealer_name of this AccountSearchFilter.
        :rtype: str
        """
        return self._dealer_name

    @dealer_name.setter
    def dealer_name(self, dealer_name):
        """Sets the dealer_name of this AccountSearchFilter.


        :param dealer_name: The dealer_name of this AccountSearchFilter.
        :type: str
        """

        self._dealer_name = dealer_name

    @property
    def dealer_reference(self):
        """Gets the dealer_reference of this AccountSearchFilter.


        :return: The dealer_reference of this AccountSearchFilter.
        :rtype: str
        """
        return self._dealer_reference

    @dealer_reference.setter
    def dealer_reference(self, dealer_reference):
        """Sets the dealer_reference of this AccountSearchFilter.


        :param dealer_reference: The dealer_reference of this AccountSearchFilter.
        :type: str
        """

        self._dealer_reference = dealer_reference

    @property
    def enabled(self):
        """Gets the enabled of this AccountSearchFilter.


        :return: The enabled of this AccountSearchFilter.
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this AccountSearchFilter.


        :param enabled: The enabled of this AccountSearchFilter.
        :type: bool
        """

        self._enabled = enabled

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccountSearchFilter):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
