# coding: utf-8

"""
    Idfy.Admin

    In this API you can manage your account details, logo, styling or manage your openid / oauth api clients. If you are a dealer you can also manage the accounts registered to this dealer.   ## Last update   Last build date for this API: 14.01.2018  

"""


import pprint
import re
from typing import List, Dict
from datetime import datetime as datetime


from idfy_sdk.services.admin.models.create_pdf_template_details_page_html import CreatePdfTemplateDetailsPageHtml
from idfy_sdk.services.admin.models.create_pdf_template_labels import CreatePdfTemplateLabels
from idfy_sdk.services.admin.models.create_pdf_template_verified_template import CreatePdfTemplateVerifiedTemplate

class PdfTemplate(object):
    """NOTE: This class is generated by Eivind.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cover_page_setting': str,
        'add_list_of_signatures_on_last_page_of_existing_pdf': bool,
        'cover_page_html': str,
        'details_page_html': CreatePdfTemplateDetailsPageHtml,
        'verified_template': CreatePdfTemplateVerifiedTemplate,
        'labels': CreatePdfTemplateLabels,
        'include_logo': bool,
        'id': str,
        'name': str,
        'last_edited': datetime
    }

    attribute_map = {
        'cover_page_setting': 'CoverPageSetting',
        'add_list_of_signatures_on_last_page_of_existing_pdf': 'AddListOfSignaturesOnLastPageOfExistingPDF',
        'cover_page_html': 'CoverPageHtml',
        'details_page_html': 'DetailsPageHtml',
        'verified_template': 'VerifiedTemplate',
        'labels': 'Labels',
        'include_logo': 'IncludeLogo',
        'id': 'Id',
        'name': 'Name',
        'last_edited': 'LastEdited'
    }

    def __init__(self, cover_page_setting=None, add_list_of_signatures_on_last_page_of_existing_pdf=None, cover_page_html=None, details_page_html=None, verified_template=None, labels=None, include_logo=None, id=None, name=None, last_edited=None):

        self._cover_page_setting = None
        self._add_list_of_signatures_on_last_page_of_existing_pdf = None
        self._cover_page_html = None
        self._details_page_html = None
        self._verified_template = None
        self._labels = None
        self._include_logo = None
        self._id = None
        self._name = None
        self._last_edited = None
        self.discriminator = None

        if cover_page_setting is not None:
            self.cover_page_setting = cover_page_setting
        if add_list_of_signatures_on_last_page_of_existing_pdf is not None:
            self.add_list_of_signatures_on_last_page_of_existing_pdf = add_list_of_signatures_on_last_page_of_existing_pdf
        if cover_page_html is not None:
            self.cover_page_html = cover_page_html
        if details_page_html is not None:
            self.details_page_html = details_page_html
        if verified_template is not None:
            self.verified_template = verified_template
        if labels is not None:
            self.labels = labels
        if include_logo is not None:
            self.include_logo = include_logo
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if last_edited is not None:
            self.last_edited = last_edited

    @property
    def cover_page_setting(self):
        """Gets the cover_page_setting of this PdfTemplate.

        Coverpage is the page added to the document at the beginning or end that show a list of the signers. This settings hides that page or put it first or last. Default firstpage

        :return: The cover_page_setting of this PdfTemplate.
        :rtype: str
        """
        return self._cover_page_setting

    @cover_page_setting.setter
    def cover_page_setting(self, cover_page_setting):
        """Sets the cover_page_setting of this PdfTemplate.

        Coverpage is the page added to the document at the beginning or end that show a list of the signers. This settings hides that page or put it first or last. Default firstpage

        :param cover_page_setting: The cover_page_setting of this PdfTemplate.
        :type: str
        """

        self._cover_page_setting = cover_page_setting

    @property
    def add_list_of_signatures_on_last_page_of_existing_pdf(self):
        """Gets the add_list_of_signatures_on_last_page_of_existing_pdf of this PdfTemplate.

        Coverpage is the page added to the document at the beginning or end that show a list of the signers. This settings hides that page or put it first or last. Default firstpage

        :return: The add_list_of_signatures_on_last_page_of_existing_pdf of this PdfTemplate.
        :rtype: bool
        """
        return self._add_list_of_signatures_on_last_page_of_existing_pdf

    @add_list_of_signatures_on_last_page_of_existing_pdf.setter
    def add_list_of_signatures_on_last_page_of_existing_pdf(self, add_list_of_signatures_on_last_page_of_existing_pdf):
        """Sets the add_list_of_signatures_on_last_page_of_existing_pdf of this PdfTemplate.

        Coverpage is the page added to the document at the beginning or end that show a list of the signers. This settings hides that page or put it first or last. Default firstpage

        :param add_list_of_signatures_on_last_page_of_existing_pdf: The add_list_of_signatures_on_last_page_of_existing_pdf of this PdfTemplate.
        :type: bool
        """

        self._add_list_of_signatures_on_last_page_of_existing_pdf = add_list_of_signatures_on_last_page_of_existing_pdf

    @property
    def cover_page_html(self):
        """Gets the cover_page_html of this PdfTemplate.

        The html template for the coverpage, if this is set it will override the default template. See our documentation on more info on how to make your own custom template.

        :return: The cover_page_html of this PdfTemplate.
        :rtype: str
        """
        return self._cover_page_html

    @cover_page_html.setter
    def cover_page_html(self, cover_page_html):
        """Sets the cover_page_html of this PdfTemplate.

        The html template for the coverpage, if this is set it will override the default template. See our documentation on more info on how to make your own custom template.

        :param cover_page_html: The cover_page_html of this PdfTemplate.
        :type: str
        """

        self._cover_page_html = cover_page_html

    @property
    def details_page_html(self):
        """Gets the details_page_html of this PdfTemplate.


        :return: The details_page_html of this PdfTemplate.
        :rtype: CreatePdfTemplateDetailsPageHtml
        """
        return self._details_page_html

    @details_page_html.setter
    def details_page_html(self, details_page_html):
        """Sets the details_page_html of this PdfTemplate.


        :param details_page_html: The details_page_html of this PdfTemplate.
        :type: CreatePdfTemplateDetailsPageHtml
        """

        self._details_page_html = details_page_html

    @property
    def verified_template(self):
        """Gets the verified_template of this PdfTemplate.


        :return: The verified_template of this PdfTemplate.
        :rtype: CreatePdfTemplateVerifiedTemplate
        """
        return self._verified_template

    @verified_template.setter
    def verified_template(self, verified_template):
        """Sets the verified_template of this PdfTemplate.


        :param verified_template: The verified_template of this PdfTemplate.
        :type: CreatePdfTemplateVerifiedTemplate
        """

        self._verified_template = verified_template

    @property
    def labels(self):
        """Gets the labels of this PdfTemplate.


        :return: The labels of this PdfTemplate.
        :rtype: CreatePdfTemplateLabels
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this PdfTemplate.


        :param labels: The labels of this PdfTemplate.
        :type: CreatePdfTemplateLabels
        """

        self._labels = labels

    @property
    def include_logo(self):
        """Gets the include_logo of this PdfTemplate.

        Include your logo in the Pdf template

        :return: The include_logo of this PdfTemplate.
        :rtype: bool
        """
        return self._include_logo

    @include_logo.setter
    def include_logo(self, include_logo):
        """Sets the include_logo of this PdfTemplate.

        Include your logo in the Pdf template

        :param include_logo: The include_logo of this PdfTemplate.
        :type: bool
        """

        self._include_logo = include_logo

    @property
    def id(self):
        """Gets the id of this PdfTemplate.


        :return: The id of this PdfTemplate.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PdfTemplate.


        :param id: The id of this PdfTemplate.
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this PdfTemplate.

        The name of the Pdf template

        :return: The name of this PdfTemplate.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PdfTemplate.

        The name of the Pdf template

        :param name: The name of this PdfTemplate.
        :type: str
        """

        self._name = name

    @property
    def last_edited(self):
        """Gets the last_edited of this PdfTemplate.

        Timestamp when the template is last edited

        :return: The last_edited of this PdfTemplate.
        :rtype: datetime
        """
        return self._last_edited

    @last_edited.setter
    def last_edited(self, last_edited):
        """Sets the last_edited of this PdfTemplate.

        Timestamp when the template is last edited

        :param last_edited: The last_edited of this PdfTemplate.
        :type: datetime
        """

        self._last_edited = last_edited

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PdfTemplate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
