# coding: utf-8

"""
    Idfy.Signature

    Sign contracts, declarations, forms and other documents using digital signatures.   ## Last update   Last build date for this endpoint: 18.03.2019

"""


import pprint
import re
from typing import List, Dict
from datetime import datetime as datetime


class HandwrittenSignature(object):
    """NOTE: This class is generated by Eivind.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'signature': str,
        'first_name': str,
        'last_name': str
    }

    attribute_map = {
        'signature': 'signature',
        'first_name': 'firstName',
        'last_name': 'lastName'
    }

    def __init__(self, signature=None, first_name=None, last_name=None):

        self._signature = None
        self._first_name = None
        self._last_name = None
        self.discriminator = None

        if signature is not None:
            self.signature = signature
        if first_name is not None:
            self.first_name = first_name
        if last_name is not None:
            self.last_name = last_name

    @property
    def signature(self):
        """Gets the signature of this HandwrittenSignature.


        :return: The signature of this HandwrittenSignature.
        :rtype: str
        """
        return self._signature

    @signature.setter
    def signature(self, signature):
        """Sets the signature of this HandwrittenSignature.


        :param signature: The signature of this HandwrittenSignature.
        :type: str
        """

        self._signature = signature

    @property
    def first_name(self):
        """Gets the first_name of this HandwrittenSignature.


        :return: The first_name of this HandwrittenSignature.
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this HandwrittenSignature.


        :param first_name: The first_name of this HandwrittenSignature.
        :type: str
        """

        self._first_name = first_name

    @property
    def last_name(self):
        """Gets the last_name of this HandwrittenSignature.


        :return: The last_name of this HandwrittenSignature.
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this HandwrittenSignature.


        :param last_name: The last_name of this HandwrittenSignature.
        :type: str
        """

        self._last_name = last_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HandwrittenSignature):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
