# coding: utf-8

"""
    Idfy.Signature

    Sign contracts, declarations, forms and other documents using digital signatures.   ## Last update   Last build date for this endpoint: 18.03.2019

"""


import pprint
import re
from typing import List, Dict
from datetime import datetime as datetime


from idfy_sdk.services.signature.models.signer_overrides import SignerOverrides

class ManualReminder(object):
    """NOTE: This class is generated by Eivind.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'notification_setting': str,
        'signers': Dict[str, SignerOverrides]
    }

    attribute_map = {
        'notification_setting': 'notificationSetting',
        'signers': 'signers'
    }

    def __init__(self, notification_setting=None, signers=None):

        self._notification_setting = None
        self._signers = None
        self.discriminator = None

        if notification_setting is not None:
            self.notification_setting = notification_setting
        if signers is not None:
            self.signers = signers

    @property
    def notification_setting(self):
        """Gets the notification_setting of this ManualReminder.

        Set what kind of reminders to send

        :return: The notification_setting of this ManualReminder.
        :rtype: str
        """
        return self._notification_setting

    @notification_setting.setter
    def notification_setting(self, notification_setting):
        """Sets the notification_setting of this ManualReminder.

        Set what kind of reminders to send

        :param notification_setting: The notification_setting of this ManualReminder.
        :type: str
        """

        self._notification_setting = notification_setting

    @property
    def signers(self):
        """Gets the signers of this ManualReminder.

        Optional: Define the signers that should receive this reminder (if not signed). Dictionary with signer id as key, you can ovveride the signer email/phone as value

        :return: The signers of this ManualReminder.
        :rtype: Dict[str, SignerOverrides]
        """
        return self._signers

    @signers.setter
    def signers(self, signers):
        """Sets the signers of this ManualReminder.

        Optional: Define the signers that should receive this reminder (if not signed). Dictionary with signer id as key, you can ovveride the signer email/phone as value

        :param signers: The signers of this ManualReminder.
        :type: Dict[str, SignerOverrides]
        """

        self._signers = signers

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ManualReminder):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
