# coding: utf-8

"""
    Idfy.Signature

    Sign contracts, declarations, forms and other documents using digital signatures.   ## Last update   Last build date for this endpoint: 18.03.2019

"""


import pprint
import re
from typing import List, Dict
from datetime import datetime as datetime


class SignatureType(object):
    """NOTE: This class is generated by Eivind.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'signature_methods': List[str],
        'mechanism': str
    }

    attribute_map = {
        'signature_methods': 'signatureMethods',
        'mechanism': 'mechanism'
    }

    def __init__(self, signature_methods=None, mechanism=None):

        self._signature_methods = None
        self._mechanism = None
        self.discriminator = None

        if signature_methods is not None:
            self.signature_methods = signature_methods
        if mechanism is not None:
            self.mechanism = mechanism

    @property
    def signature_methods(self):
        """Gets the signature_methods of this SignatureType.

        A list of signature methods that the signer is allowed to use when signing the document.  If not specified, all available signature methods for your Idfy account will be displayed to the signer.

        :return: The signature_methods of this SignatureType.
        :rtype: List[str]
        """
        return self._signature_methods

    @signature_methods.setter
    def signature_methods(self, signature_methods):
        """Sets the signature_methods of this SignatureType.

        A list of signature methods that the signer is allowed to use when signing the document.  If not specified, all available signature methods for your Idfy account will be displayed to the signer.

        :param signature_methods: The signature_methods of this SignatureType.
        :type: List[str]
        """

        self._signature_methods = signature_methods

    @property
    def mechanism(self):
        """Gets the mechanism of this SignatureType.


        :return: The mechanism of this SignatureType.
        :rtype: str
        """
        return self._mechanism

    @mechanism.setter
    def mechanism(self, mechanism):
        """Sets the mechanism of this SignatureType.


        :param mechanism: The mechanism of this SignatureType.
        :type: str
        """

        self._mechanism = mechanism

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SignatureType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
