# coding: utf-8

"""
    Idfy.Signature

    Sign contracts, declarations, forms and other documents using digital signatures.   ## Last update   Last build date for this endpoint: 18.03.2019

"""


import pprint
import re
from typing import List, Dict
from datetime import datetime as datetime


class Status(object):
    """NOTE: This class is generated by Eivind.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'document_status': str,
        'completed_packages': List[str],
        'attachment_packages': Dict[str, List[str]]
    }

    attribute_map = {
        'document_status': 'documentStatus',
        'completed_packages': 'completedPackages',
        'attachment_packages': 'attachmentPackages'
    }

    def __init__(self, document_status=None, completed_packages=None, attachment_packages=None):

        self._document_status = None
        self._completed_packages = None
        self._attachment_packages = None
        self.discriminator = None

        if document_status is not None:
            self.document_status = document_status
        if completed_packages is not None:
            self.completed_packages = completed_packages
        if attachment_packages is not None:
            self.attachment_packages = attachment_packages

    @property
    def document_status(self):
        """Gets the document_status of this Status.

        The overall status of the document.

        :return: The document_status of this Status.
        :rtype: str
        """
        return self._document_status

    @document_status.setter
    def document_status(self, document_status):
        """Sets the document_status of this Status.

        The overall status of the document.

        :param document_status: The document_status of this Status.
        :type: str
        """

        self._document_status = document_status

    @property
    def completed_packages(self):
        """Gets the completed_packages of this Status.

        A list of all the completed files/packages for the main document.

        :return: The completed_packages of this Status.
        :rtype: List[str]
        """
        return self._completed_packages

    @completed_packages.setter
    def completed_packages(self, completed_packages):
        """Sets the completed_packages of this Status.

        A list of all the completed files/packages for the main document.

        :param completed_packages: The completed_packages of this Status.
        :type: List[str]
        """

        self._completed_packages = completed_packages

    @property
    def attachment_packages(self):
        """Gets the attachment_packages of this Status.

        A set of key-value pairs with all the completed packages for the signable attachments, where the key is equal to the attachment's ID.

        :return: The attachment_packages of this Status.
        :rtype: Dict[str, List[str]]
        """
        return self._attachment_packages

    @attachment_packages.setter
    def attachment_packages(self, attachment_packages):
        """Sets the attachment_packages of this Status.

        A set of key-value pairs with all the completed packages for the signable attachments, where the key is equal to the attachment's ID.

        :param attachment_packages: The attachment_packages of this Status.
        :type: Dict[str, List[str]]
        """

        self._attachment_packages = attachment_packages

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Status):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
